﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

namespace HeuristicLab.Problems.DataAnalysis.Symbolic.ConstantsOptimization {
  public class VariableData {
    public readonly string variableName;
    public readonly string variableValue; // for factor variables
    public readonly int lag;

    public VariableData(string varName, string varValue, int lag) {
      this.variableName = varName;
      this.variableValue = varValue;
      this.lag = lag;
    }

    public override bool Equals(object obj) {
      var other = obj as VariableData;
      if (other == null) return false;
      return other.variableName.Equals(this.variableName) &&
             other.variableValue.Equals(this.variableValue) &&
             other.lag == this.lag;
    }

    public override int GetHashCode() {
      return variableName.GetHashCode() ^ variableValue.GetHashCode() ^ lag;
    }
  }
}
